// NewsWatcher 2.1 "myTools.h"
// Copyright (C) 1994-1996 Mizutori Tetsuya
// 1994/5/24, 1994/7/15, 1995/1/15, 1995/2/8, 1995/7/14

// Define MZTR patch levels
#define MZTR_PATCH			1

// Define Constants and Macros
// JIS Kanji sequence
// New JIS: ESC + '$' + 'B' + [ JIS codes ] + ESC + '(' + 'J'
// Old JIS: ESC + '$' + '@' + [ JIS codes ] + ESC + '(' + 'B'

#define	ESC		'\033'
#define	KIN		'$'
#define	KIN1	'B'
#define	KIN2	'@'
#define	KOUT	'('
#define	KOUT1	'J'
#define	KOUT2	'B'

#define WORD_AT( p )  	(* (unsigned short *) (p))
#define	BYTE_AT( p, n )	(* ( ((unsigned char *) (p)) + (n) ) )

#define	WORD_BY( H, L )	( (((unsigned short) (H))<<8) | (unsigned short) (L) )


// Global and Constant variables

//extern Boolean gOptionPressed;		/* true if Option-Key is pressed on startup */


// Prototype

/***** Keyboard sensing *****/
//Boolean	IsPressed ( unsigned short k );

/**** Kanji code conversion *****/
Boolean IsJIS  ( unsigned short d );
Boolean IsSJIS ( unsigned short d );
Boolean IsEUC  ( unsigned short d );
unsigned short EUC2JIS  ( unsigned short d );
unsigned short JIS2EUC  ( unsigned short d );
unsigned short SJIS2JIS ( unsigned short d );
unsigned short JIS2SJIS ( unsigned short d );
unsigned short EUC2SJIS ( unsigned short d );
unsigned short SJIS2EUC ( unsigned short d );

Boolean IsKanji ( char *p, char *pStart, char *pEnd );
long SkipOnBrace ( char *p, char *pStart, char *pEnd );

OSErr MyResizeHandle ( void *handle, Size len );

long GetFillColumn ( void );


// Macros used in 'net.c'

#define if_COUNT_SJIS_KANJI(n,p,pEnd)	\
	if ( IsSJIS( WORD_AT(p) ) )									\
	{															\
		n += 3;													\
		while ( p < pEnd && IsSJIS( WORD_AT(p) ) )  p += 2;		\
		n += 3;													\
	}


#define if_SJIS_KANJI(p,q,pEnd)	\
	if ( IsSJIS( WORD_AT(p) ) )									\
	{															\
		unsigned short	d;										\
		*q++ = ESC; *q++ = KIN; *q++ = KIN1;					\
		while ( p < pEnd && IsSJIS( d = WORD_AT(p) ) ) {		\
			d = SJIS2JIS(d);									\
			WORD_AT(q) = d;										\
			q += 2; p += 2; }									\
		*q++ = ESC; *q++ = KOUT; *q++ = KOUT1;					\
	}


#define if_JIS_KANJI(p,q,pEnd)	\
	if ( *p==ESC && *(p+1)==KIN && ( *(p+2)==KIN1 || *(p+2)==KIN2) )	\
	{															\
		unsigned short	d;										\
		p += 3;													\
		while ( p < pEnd ) {									\
			if ( *p==ESC && *(p+1)==KOUT && ( *(p+2)==KOUT1 || *(p+2)==KOUT2) ) {	\
				p += 3; break; }								\
			d = WORD_AT(p);										\
			d = JIS2SJIS(d);									\
			WORD_AT(q) = d;										\
			p += 2; q += 2;										\
		}														\
	}


// Macros used in 'news.c'

#define if_JIS_KANJI_CHUNK(p,t,tLen,c,gFileLinePos)	\
		   if (c==ESC && d==KIN) {		\
		gEscapeKanjiIn = true;				\
		t++; c = *t; ++t;					\
		tLen -= 2;							\
	} else if ( gEscapeKanjiIn ) {		\
		if (c==KIN1 || c==KIN2) {			\
			gInKanjiSequence = true;		\
		} else {							\
			*p++ = ESC;						\
			*p++ = KIN;						\
			*p++ = c;						\
		}									\
		gEscapeKanjiIn = false;				\
		c = d;								\
		t++;								\
		tLen--;								\
	} else if (c==ESC && d==KOUT) {		\
		gEscapeKanjiOut = true;				\
		t++; c = *t; ++t;					\
		tLen -= 2;							\
	} else if ( gEscapeKanjiOut ) {		\
		if (c==KOUT1 || c==KOUT2) {			\
			gInKanjiSequence = false;		\
		} else {							\
			*p++ = ESC;						\
			*p++ = KOUT;					\
			*p++ = c;						\
		}									\
		gEscapeKanjiOut = false;			\
		c = d;								\
		t++;								\
		tLen--;								\
	} else if ( gInKanjiSequence ) {	\
		unsigned short	dd;					\
		dd = WORD_BY(c,d);					\
		if ( IsJIS(dd) ) {					\
			dd = JIS2SJIS(dd);				\
			WORD_AT(p) = dd;				\
			p += 2;							\
			t += 2;	tLen -= 2;				\
			gFileLinePos += 2;				\
			c = *(t-1);						\
		} else {							\
			gInKanjiSequence = false;		\
		}									\
	}

// end of header file
